//#line 2 "/opt/ros/cturtle/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the kinect_camera package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __kinect_camera__KINECTCONFIG_H__
#define __kinect_camera__KINECTCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace kinect_camera
{
  class KinectConfigStatics;
  
  class KinectConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(KinectConfig &config, const KinectConfig &max, const KinectConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const KinectConfig &config1, const KinectConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, KinectConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const KinectConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, KinectConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const KinectConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T KinectConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (KinectConfig::* field);

      virtual void clamp(KinectConfig &config, const KinectConfig &max, const KinectConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const KinectConfig &config1, const KinectConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, KinectConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const KinectConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, KinectConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const KinectConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 12 "../cfg/Kinect.cfg"
      double max_range;
//#line 18 "../cfg/Kinect.cfg"
      int color_format;
//#line 28 "../cfg/Kinect.cfg"
      int led;
//#line 30 "../cfg/Kinect.cfg"
      double tilt;
//#line 138 "/opt/ros/cturtle/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("KinectConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const KinectConfig &__max__ = __getMax__();
      const KinectConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const KinectConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const KinectConfig &__getDefault__();
    static const KinectConfig &__getMax__();
    static const KinectConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const KinectConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void KinectConfig::ParamDescription<std::string>::clamp(KinectConfig &config, const KinectConfig &max, const KinectConfig &min) const
  {
    return;
  }

  class KinectConfigStatics
  {
    friend class KinectConfig;
    
    KinectConfigStatics()
    {
//#line 12 "../cfg/Kinect.cfg"
      __min__.max_range = 1.0;
//#line 12 "../cfg/Kinect.cfg"
      __max__.max_range = 10.0;
//#line 12 "../cfg/Kinect.cfg"
      __default__.max_range = 5.0;
//#line 12 "../cfg/Kinect.cfg"
      __param_descriptions__.push_back(KinectConfig::AbstractParamDescriptionConstPtr(new KinectConfig::ParamDescription<double>("max_range", "double", 0, "Cut off depth readings beyond this range", "", &KinectConfig::max_range)));
//#line 18 "../cfg/Kinect.cfg"
      __min__.color_format = 0;
//#line 18 "../cfg/Kinect.cfg"
      __max__.color_format = 2;
//#line 18 "../cfg/Kinect.cfg"
      __default__.color_format = 0;
//#line 18 "../cfg/Kinect.cfg"
      __param_descriptions__.push_back(KinectConfig::AbstractParamDescriptionConstPtr(new KinectConfig::ParamDescription<int>("color_format", "int", 0, "Encoding of the raw image", "{'enum_description': 'Enum to set the color image format', 'enum': [{'srcline': 14, 'description': 'RGB color', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'RGB'}, {'srcline': 15, 'description': 'Raw Bayer data', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Bayer'}, {'srcline': 16, 'description': 'Raw IR data', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'IR'}]}", &KinectConfig::color_format)));
//#line 28 "../cfg/Kinect.cfg"
      __min__.led = 0;
//#line 28 "../cfg/Kinect.cfg"
      __max__.led = 6;
//#line 28 "../cfg/Kinect.cfg"
      __default__.led = 5;
//#line 28 "../cfg/Kinect.cfg"
      __param_descriptions__.push_back(KinectConfig::AbstractParamDescriptionConstPtr(new KinectConfig::ParamDescription<int>("led", "int", 0, "LED mode", "{'enum_description': 'Enum to set the LED mode', 'enum': [{'srcline': 20, 'description': 'Off', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'Off'}, {'srcline': 21, 'description': 'Green', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Green'}, {'srcline': 22, 'description': 'Red', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'Red'}, {'srcline': 23, 'description': 'Yellow', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'Yellow'}, {'srcline': 24, 'description': 'Blink yellow', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 4, 'ctype': 'int', 'type': 'int', 'name': 'BlinkYellow'}, {'srcline': 25, 'description': 'Blink green', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 5, 'ctype': 'int', 'type': 'int', 'name': 'BlinkGreen'}, {'srcline': 26, 'description': 'Blink red and yellow', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 6, 'ctype': 'int', 'type': 'int', 'name': 'BlinkRedYellow'}]}", &KinectConfig::led)));
//#line 30 "../cfg/Kinect.cfg"
      __min__.tilt = -31.0;
//#line 30 "../cfg/Kinect.cfg"
      __max__.tilt = 31.0;
//#line 30 "../cfg/Kinect.cfg"
      __default__.tilt = 0.0;
//#line 30 "../cfg/Kinect.cfg"
      __param_descriptions__.push_back(KinectConfig::AbstractParamDescriptionConstPtr(new KinectConfig::ParamDescription<double>("tilt", "double", 0, "Control the tilt motor, degrees", "", &KinectConfig::tilt)));
//#line 239 "/opt/ros/cturtle/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<KinectConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<KinectConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    KinectConfig __max__;
    KinectConfig __min__;
    KinectConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const KinectConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static KinectConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &KinectConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const KinectConfig &KinectConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const KinectConfig &KinectConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const KinectConfig &KinectConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<KinectConfig::AbstractParamDescriptionConstPtr> &KinectConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const KinectConfigStatics *KinectConfig::__get_statics__()
  {
    const static KinectConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = KinectConfigStatics::get_instance();
    
    return statics;
  }

//#line 14 "../cfg/Kinect.cfg"
      const int Kinect_RGB = 0;
//#line 15 "../cfg/Kinect.cfg"
      const int Kinect_Bayer = 1;
//#line 16 "../cfg/Kinect.cfg"
      const int Kinect_IR = 2;
//#line 20 "../cfg/Kinect.cfg"
      const int Kinect_Off = 0;
//#line 21 "../cfg/Kinect.cfg"
      const int Kinect_Green = 1;
//#line 22 "../cfg/Kinect.cfg"
      const int Kinect_Red = 2;
//#line 23 "../cfg/Kinect.cfg"
      const int Kinect_Yellow = 3;
//#line 24 "../cfg/Kinect.cfg"
      const int Kinect_BlinkYellow = 4;
//#line 25 "../cfg/Kinect.cfg"
      const int Kinect_BlinkGreen = 5;
//#line 26 "../cfg/Kinect.cfg"
      const int Kinect_BlinkRedYellow = 6;
}

#endif // __KINECTRECONFIGURATOR_H__
