## *********************************************************
## 
## File autogenerated for the kinect_camera package 
## by the dynamic_reconfigure package.
## Please do not edit.
## 
## ********************************************************/

##**********************************************************
## Software License Agreement (BSD License)
##
##  Copyright (c) 2008, Willow Garage, Inc.
##  All rights reserved.
##
##  Redistribution and use in source and binary forms, with or without
##  modification, are permitted provided that the following conditions
##  are met:
##
##   * Redistributions of source code must retain the above copyright
##     notice, this list of conditions and the following disclaimer.
##   * Redistributions in binary form must reproduce the above
##     copyright notice, this list of conditions and the following
##     disclaimer in the documentation and/or other materials provided
##     with the distribution.
##   * Neither the name of the Willow Garage nor the names of its
##     contributors may be used to endorse or promote products derived
##     from this software without specific prior written permission.
##
##  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
##  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
##  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
##  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
##  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
##  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
##  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
##  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
##  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
##  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
##  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
##  POSSIBILITY OF SUCH DAMAGE.
##**********************************************************/

config_description = [{'srcline': 12, 'description': 'Cut off depth readings beyond this range', 'max': 10.0, 'cconsttype': 'const double', 'ctype': 'double', 'srcfile': '../cfg/Kinect.cfg', 'name': 'max_range', 'edit_method': '', 'default': 5.0, 'level': 0, 'min': 1.0, 'type': 'double'}, {'srcline': 18, 'description': 'Encoding of the raw image', 'max': 2, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/Kinect.cfg', 'name': 'color_format', 'edit_method': "{'enum_description': 'Enum to set the color image format', 'enum': [{'srcline': 14, 'description': 'RGB color', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'RGB'}, {'srcline': 15, 'description': 'Raw Bayer data', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Bayer'}, {'srcline': 16, 'description': 'Raw IR data', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'IR'}]}", 'default': 0, 'level': 0, 'min': 0, 'type': 'int'}, {'srcline': 28, 'description': 'LED mode', 'max': 6, 'cconsttype': 'const int', 'ctype': 'int', 'srcfile': '../cfg/Kinect.cfg', 'name': 'led', 'edit_method': "{'enum_description': 'Enum to set the LED mode', 'enum': [{'srcline': 20, 'description': 'Off', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 0, 'ctype': 'int', 'type': 'int', 'name': 'Off'}, {'srcline': 21, 'description': 'Green', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 1, 'ctype': 'int', 'type': 'int', 'name': 'Green'}, {'srcline': 22, 'description': 'Red', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 2, 'ctype': 'int', 'type': 'int', 'name': 'Red'}, {'srcline': 23, 'description': 'Yellow', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 3, 'ctype': 'int', 'type': 'int', 'name': 'Yellow'}, {'srcline': 24, 'description': 'Blink yellow', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 4, 'ctype': 'int', 'type': 'int', 'name': 'BlinkYellow'}, {'srcline': 25, 'description': 'Blink green', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 5, 'ctype': 'int', 'type': 'int', 'name': 'BlinkGreen'}, {'srcline': 26, 'description': 'Blink red and yellow', 'srcfile': '../cfg/Kinect.cfg', 'cconsttype': 'const int', 'value': 6, 'ctype': 'int', 'type': 'int', 'name': 'BlinkRedYellow'}]}", 'default': 5, 'level': 0, 'min': 0, 'type': 'int'}, {'srcline': 30, 'description': 'Control the tilt motor, degrees', 'max': 31.0, 'cconsttype': 'const double', 'ctype': 'double', 'srcfile': '../cfg/Kinect.cfg', 'name': 'tilt', 'edit_method': '', 'default': 0.0, 'level': 0, 'min': -31.0, 'type': 'double'}]

min = {}
max = {}
defaults = {}
level = {}
type = {}
all_level = 0

for param in config_description:
    min[param['name']] = param['min']
    max[param['name']] = param['max']
    defaults[param['name']] = param['default']
    level[param['name']] = param['level']
    type[param['name']] = param['type']
    all_level = all_level | param['level']

Kinect_RGB = 0
Kinect_Bayer = 1
Kinect_IR = 2
Kinect_Off = 0
Kinect_Green = 1
Kinect_Red = 2
Kinect_Yellow = 3
Kinect_BlinkYellow = 4
Kinect_BlinkGreen = 5
Kinect_BlinkRedYellow = 6
